#include "../stdafx.h"
#include "phidget_jni.h"
#include "com_phidgets_StepperPhidget.h"
#include "../cphidgetstepper.h"

EVENT_VARS(stepperPositionChange, StepperPositionChange)
EVENT_VARS(inputChange, InputChange)
EVENT_VARS(stepperVelocityChange, StepperVelocityChange)
EVENT_VARS(currentChange, CurrentChange)

JNI_LOAD(stepper, Stepper)
	EVENT_VAR_SETUP(stepper, stepperPositionChange, StepperPositionChange, IJ, V)
	EVENT_VAR_SETUP(stepper, inputChange, InputChange, IZ, V)
	EVENT_VAR_SETUP(stepper, stepperVelocityChange, StepperVelocityChange, ID, V)
	EVENT_VAR_SETUP(stepper, currentChange, CurrentChange, ID, V)
}

EVENT_HANDLER_INDEXED(Stepper, stepperPositionChange, StepperPositionChange, 
					  CPhidgetStepper_set_OnPositionChange_Handler, long long)
EVENT_HANDLER_INDEXED(Stepper, inputChange, InputChange, 
					  CPhidgetStepper_set_OnInputChange_Handler, int)
EVENT_HANDLER_INDEXED(Stepper, stepperVelocityChange, StepperVelocityChange, 
					  CPhidgetStepper_set_OnSpeedChange_Handler, double)
EVENT_HANDLER_INDEXED(Stepper, currentChange, CurrentChange, 
					  CPhidgetStepper_set_OnCurrentChange_Handler, double)

JNI_CREATE(Stepper)
JNI_INDEXED_GETFUNC(Stepper, Acceleration, Acceleration, jdouble)
JNI_INDEXED_SETFUNC(Stepper, Acceleration, Acceleration, jdouble)
JNI_INDEXED_GETFUNC(Stepper, AccelerationMin, AccelerationMin, jdouble)
JNI_INDEXED_GETFUNC(Stepper, AccelerationMax, AccelerationMax, jdouble)
JNI_INDEXED_GETFUNC(Stepper, Velocity, MotorSpeed, jdouble)
JNI_INDEXED_SETFUNC(Stepper, MaxVelocity, MotorSpeed, jdouble)
JNI_INDEXED_GETFUNC(Stepper, VelocityMin, MotorSpeedMin, jdouble)
JNI_INDEXED_GETFUNC(Stepper, VelocityMax, MotorSpeedMax, jdouble)
JNI_INDEXED_GETFUNC(Stepper, Position, MotorPosition, jlong)
JNI_INDEXED_SETFUNC(Stepper, Position, MotorPosition, jlong)
JNI_INDEXED_GETFUNC(Stepper, PositionMin, MotorPositionMin, jlong)
JNI_INDEXED_GETFUNC(Stepper, PositionMax, MotorPositionMax, jlong)
JNI_INDEXED_GETFUNC(Stepper, Current, Current, jdouble)
JNI_INDEXED_SETFUNC(Stepper, Torque, Torque, jdouble)
JNI_GETFUNC(Stepper, MotorCount, NumMotors, jint)
JNI_GETFUNC(Stepper, InputCount, NumInputs, jint)
