#ifndef _CLOG
#define _CLOG

typedef enum {
	PHIDGET_LOG_CRITICAL = 1,	/* Really important errors that can't be recovered */
	PHIDGET_LOG_ERROR,			/* Errors that are recovered from */
	PHIDGET_LOG_WARNING,		/* Warning's about weird things that aren't neccesarily wrong */
	PHIDGET_LOG_DEBUG,			/* Should only be used during development - only shows up in the debug library*/
	PHIDGET_LOG_INFO,			/* Info about the going on's in the library */
	PHIDGET_LOG_VERBOSE			/* Everything, including user activity */
} CPhidgetLog_level;

PHIDGET21_API int CCONV CPhidget_enableLogging(CPhidgetLog_level level, const char *outputFile);
PHIDGET21_API int CCONV CPhidget_disableLogging();
PHIDGET21_API int CCONV CPhidget_log(CPhidgetLog_level level, char *msg, const char *fmt, ...);

#ifndef EXTERNALPROTO

#define STRINGIFY(x) #x
#define TOSTRING(x) STRINGIFY(x)
#define LOG(level, ...) CPhidget_log(level, __FILE__ "(" TOSTRING(__LINE__) ")", __VA_ARGS__)

#endif

#endif
