#ifndef __CPHIDGETADVANCEDSERVO
#define __CPHIDGETADVANCEDSERVO

DPHANDLE(AdvancedServo)
CHDRSTANDARD(AdvancedServo)

CHDRGET(AdvancedServo,NumMotors,int)

CHDRGETSETINDEX(AdvancedServo,Acceleration,double)
CHDRGETINDEX(AdvancedServo,AccelerationMax,double)
CHDRGETINDEX(AdvancedServo,AccelerationMin,double)

//set velocity
CHDRGETSETINDEX(AdvancedServo,MaxVelocity,double)
//Actual velocity
CHDRGETINDEX(AdvancedServo,Velocity,double)
CHDRGETINDEX(AdvancedServo,VelocityMax,double)
CHDRGETINDEX(AdvancedServo,VelocityMin,double)
CHDREVENTINDEX(AdvancedServo,VelocityChange,double)

CHDRGETSETINDEX(AdvancedServo,MotorPosition,double)
CHDRGETINDEX(AdvancedServo,MotorPositionMax,double)
CHDRGETINDEX(AdvancedServo,MotorPositionMin,double)
CHDREVENTINDEX(AdvancedServo,PositionChange,double)

CHDRGETINDEX(AdvancedServo,Current,double)
CHDREVENTINDEX(AdvancedServo,CurrentChange,double)

CHDRGETSETINDEX(AdvancedServo,SpeedRampingOn,int)
CHDRGETSETINDEX(AdvancedServo,MotorOn,int)

#ifndef EXTERNALPROTO
#define ADVSERVO_MAXSERVOS 8

//Flags - need to match those defined in firmware
#define NO_RAMPING_FLAG 0x01
#define STOP_FLAG 0x02

struct _CPhidgetAdvancedServo {
	CPhidget phid;

	int (CCONV *fptrPositionChange)(CPhidgetAdvancedServoHandle, void *, int, double);
	int (CCONV *fptrVelocityChange)(CPhidgetAdvancedServoHandle, void *, int, double);
	int (CCONV *fptrCurrentChange)(CPhidgetAdvancedServoHandle, void *, int, double);

	void *fptrPositionChangeptr;
	void *fptrVelocityChangeptr;
	void *fptrCurrentChangeptr;
	
	//data from the device
	double motorVelocityEcho[ADVSERVO_MAXSERVOS];
	double motorPositionEcho[ADVSERVO_MAXSERVOS];
	double motorSensedCurrent[ADVSERVO_MAXSERVOS];
	//int motorSpeedRampingStateEcho[ADVSERVO_MAXSERVOS]; //not currently used
	//int motorEngagedStateEcho[ADVSERVO_MAXSERVOS]; //not currently used

	//data from the user
	double motorPosition[ADVSERVO_MAXSERVOS];
	double motorAcceleration[ADVSERVO_MAXSERVOS];
	double motorVelocity[ADVSERVO_MAXSERVOS];
	int motorSpeedRampingState[ADVSERVO_MAXSERVOS];
	int motorEngagedState[ADVSERVO_MAXSERVOS];
	
	double velocityMax, velocityMin;
	double accelerationMax, accelerationMin;
	double motorPositionMax, motorPositionMin;

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;
} typedef CPhidgetAdvancedServoInfo;
#endif

#endif
