#ifndef __CPHIDGETINTERFACEKIT
#define __CPHIDGETINTERFACEKIT

DPHANDLE(InterfaceKit)
CHDRSTANDARD(InterfaceKit)

CHDRGET(InterfaceKit, NumInputs, int)
CHDRGETINDEX(InterfaceKit, InputState, int)
CHDREVENTINDEX(InterfaceKit, InputChange, int)

CHDRGET(InterfaceKit, NumOutputs, int)
CHDRGETSETINDEX(InterfaceKit, OutputState, int)
CHDREVENTINDEX(InterfaceKit, OutputChange, int)

CHDRGET(InterfaceKit, NumSensors, int)
CHDRGETINDEX(InterfaceKit, SensorValue, int)
CHDRGETINDEX(InterfaceKit, SensorRawValue, int)
CHDREVENTINDEX(InterfaceKit, SensorChange, int)
CHDRGETSETINDEX(InterfaceKit, SensorChangeTrigger, int)
CHDRGETSET(InterfaceKit, Ratiometric, int)

#ifndef EXTERNALPROTO
#define IFKIT_MAXINPUTS 32
#define IFKIT_MAXOUTPUTS 32
#define IFKIT_MAXSENSORS 8

#define IFKIT_MAXSENSORCHANGE 1000 //BL: Had to check for this, might as well use a define

struct _CPhidgetInterfaceKit {
	CPhidget phid;

	int (CCONV *fptrOutputChange)(CPhidgetInterfaceKitHandle, void *, int, int);
	int (CCONV *fptrInputChange)(CPhidgetInterfaceKitHandle, void *, int, int);
	int (CCONV *fptrSensorChange)(CPhidgetInterfaceKitHandle, void *, int, int);

	void *fptrOutputChangeptr;
	void *fptrInputChangeptr;
	void *fptrSensorChangeptr;

	unsigned char ratiometric;

	// output fields all protected by outputLock
	unsigned char outputStates[IFKIT_MAXOUTPUTS];
	unsigned char nextOutputStates[IFKIT_MAXOUTPUTS];
	unsigned char changedOutputs[IFKIT_MAXOUTPUTS];
	int lastChangedOutput;

	unsigned char outputEchoStates[IFKIT_MAXOUTPUTS];		// Values returned from the device
	unsigned char physicalState[IFKIT_MAXINPUTS];

	int sensorChangeTrigger[IFKIT_MAXSENSORS];
	int sensorRawValue[IFKIT_MAXSENSORS];
	int sensorValue[IFKIT_MAXSENSORS];
	int sensorLastValue[IFKIT_MAXSENSORS];

	unsigned char fullStateEcho;
} typedef CPhidgetInterfaceKitInfo;
#endif

#endif
