#ifndef __CPHIDGETMOTORCONTROL
#define __CPHIDGETMOTORCONTROL

DPHANDLE(MotorControl)
CHDRSTANDARD(MotorControl)

CHDRGET(MotorControl,NumMotors,int)

CHDRGETSETINDEX(MotorControl,MotorSpeed,double)
CHDREVENTINDEX(MotorControl,MotorChange,double)

CHDRGETSETINDEX(MotorControl,Acceleration,double)
CHDRGETINDEX(MotorControl,AccelerationMax,double)
CHDRGETINDEX(MotorControl,AccelerationMin,double)

CHDRGETINDEX(MotorControl,Current,double)
CHDREVENTINDEX(MotorControl,CurrentChange,double)

CHDRGET(MotorControl,NumInputs,int)
CHDRGETINDEX(MotorControl,InputState,int)
CHDREVENTINDEX(MotorControl,InputChange,int)

#ifndef EXTERNALPROTO
#define MOTORCONTROL_MAXMOTORS 2
#define MOTORCONTROL_MAXINPUTS 4
struct _CPhidgetMotorControl {
	CPhidget phid;

	int (CCONV *fptrMotorChange)(CPhidgetMotorControlHandle, void *, int, double);                 
	int (CCONV *fptrInputChange)(CPhidgetMotorControlHandle, void *, int, int);     
	int (CCONV *fptrCurrentChange)(CPhidgetMotorControlHandle, void *, int, double);       

	void *fptrInputChangeptr;
	void *fptrMotorChangeptr;
	void *fptrCurrentChangeptr;

	unsigned char inputState[MOTORCONTROL_MAXINPUTS];
	double motorSpeedEcho[MOTORCONTROL_MAXMOTORS];
	double motorSensedCurrent[MOTORCONTROL_MAXMOTORS];

	double motorSpeed[MOTORCONTROL_MAXMOTORS];
	double motorAcceleration[MOTORCONTROL_MAXMOTORS];

	double accelerationMax, accelerationMin;

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;
} typedef CPhidgetMotorControlInfo;
#endif


#endif
