#ifndef __CPHIDGETRFID
#define __CPHIDGETRFID

DPHANDLE(RFID)
CHDRSTANDARD(RFID)

CHDRGET(RFID,NumOutputs,int)
CHDRGETSETINDEX(RFID,OutputState,int)
CHDREVENTINDEX(RFID,OutputChange,int)

CHDRGETSET(RFID,AntennaOn,int)
CHDRGETSET(RFID,LEDOn,int)

CHDRGET(RFID,LastTag,unsigned char)
CHDRGET(RFID,TagStatus,int)
CHDREVENT(RFID,Tag,unsigned char *)
CHDREVENT(RFID,TagLost,unsigned char *)

#ifndef EXTERNALPROTO

#define RFID_PACKET_TAG 0
#define RFID_PACKET_OUTPUT_ECHO 1

#define RFID_LED_FLAG 0x04
#define RFID_ANTENNA_FLAG 0x08

#define RFID_MAXOUTPUTS 2

struct _CPhidgetRFID {
	CPhidget phid;

	int (CCONV *fptrOutputChange)(CPhidgetRFIDHandle, void *, int, int);
	int (CCONV *fptrTag)(CPhidgetRFIDHandle, void *, unsigned char *);
	int (CCONV *fptrTagLost)(CPhidgetRFIDHandle, void *, unsigned char *);

	void *fptrOutputChangeptr;
	void *fptrTagptr;
	void *fptrTagLostptr;

	// Values returned from the device
	unsigned char outputEchoState[RFID_MAXOUTPUTS];
	unsigned char antennaEchoState;
	unsigned char ledEchoState;
	
	unsigned char outputState[RFID_MAXOUTPUTS];
	unsigned char antennaState;
	unsigned char ledState;

	unsigned char lastTag[5];
	TIME	lastTagTime;
	unsigned char tagPresent;

	unsigned char fullStateEcho;
	
	CThread tagTimerThread;

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;
} typedef CPhidgetRFIDInfo;
#endif


#endif
