#ifndef __CPHIDGETSTEPPER
#define __CPHIDGETSTEPPER

DPHANDLE(Stepper)
CHDRSTANDARD(Stepper)

CHDRGET(Stepper,NumInputs,int)
CHDRGETINDEX(Stepper,InputState,int)
CHDREVENTINDEX(Stepper,InputChange,int)

CHDRGET(Stepper,NumMotors,int)

CHDRGETSETINDEX(Stepper,Acceleration,double)
CHDRGETINDEX(Stepper,AccelerationMax,double)
CHDRGETINDEX(Stepper,AccelerationMin,double)

CHDRGETSETINDEX(Stepper,MotorSpeed,double)
CHDRGETINDEX(Stepper,MotorSpeedMax,double)
CHDRGETINDEX(Stepper,MotorSpeedMin,double)
CHDREVENTINDEX(Stepper,SpeedChange,double)

CHDRGETSETINDEX(Stepper,MotorPosition,long long)
CHDRGETINDEX(Stepper,MotorPositionMax,long long)
CHDRGETINDEX(Stepper,MotorPositionMin,long long)
CHDREVENTINDEX(Stepper,PositionChange,long long)

CHDRGETINDEX(Stepper,Current,double)
CHDREVENTINDEX(Stepper,CurrentChange,double)

CHDRSETINDEX(Stepper,Torque,double)

#ifndef EXTERNALPROTO
#define STEPPER_MAXSTEPPERS 8
#define STEPPER_MAXINPUTS 8

#define BIPOLAR_STEPPER_CURRENT_SENSE_GAIN 8.5

struct _CPhidgetStepper{
	CPhidget phid;
          
	int (CCONV *fptrPositionChange)(CPhidgetStepperHandle, void *, int, long long);        
	int (CCONV *fptrSpeedChange)(CPhidgetStepperHandle, void *, int, double);                   
	int (CCONV *fptrCurrentChange)(CPhidgetStepperHandle, void *, int, double);       
	int (CCONV *fptrInputChange)(CPhidgetStepperHandle, void *, int, int);           

	void *fptrPositionChangeptr;
	void *fptrInputChangeptr;
	void *fptrCurrentChangeptr;
	void *fptrSpeedChangeptr;

	//data from the device
	unsigned char inputState[STEPPER_MAXINPUTS];
	long long motorPositionEcho[STEPPER_MAXSTEPPERS];
	double motorSpeedEcho[STEPPER_MAXSTEPPERS];
	double motorSensedCurrent[STEPPER_MAXSTEPPERS];

	//data from the user
	long long motorPosition[STEPPER_MAXSTEPPERS];
	double motorAcceleration[STEPPER_MAXSTEPPERS];
	double motorSpeed[STEPPER_MAXSTEPPERS];
	double motorTorque[STEPPER_MAXSTEPPERS];
	
	double motorSpeedMax, motorSpeedMin;
	double accelerationMax, accelerationMin;
	long long motorPositionMax, motorPositionMin;
	int microSteps;

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;
} typedef CPhidgetStepperInfo;
#endif


#endif

