#ifndef __CPHIDGETTEMPERATURESENSOR
#define __CPHIDGETTEMPERATURESENSOR

DPHANDLE(TemperatureSensor)
CHDRSTANDARD(TemperatureSensor)

typedef enum {
	PHIDGET_TEMPERATURE_SENSOR_K_TYPE = 1,
	PHIDGET_TEMPERATURE_SENSOR_J_TYPE,
	PHIDGET_TEMPERATURE_SENSOR_E_TYPE,
	PHIDGET_TEMPERATURE_SENSOR_T_TYPE
}  CPhidgetTemperatureSensor_ThermocoupleType;

CHDRGET(TemperatureSensor,NumTemperatureInputs,int)
CHDRGETINDEX(TemperatureSensor,Temperature,double)
CHDRGETINDEX(TemperatureSensor,TemperatureMax,double)
CHDRGETINDEX(TemperatureSensor,TemperatureMin,double)
CHDREVENTINDEX(TemperatureSensor,TemperatureChange,double)
CHDRGETSETINDEX(TemperatureSensor,TemperatureChangeTrigger,double)

CHDRGETINDEX(TemperatureSensor,Potential,double)
CHDRGETINDEX(TemperatureSensor,PotentialMax,double)
CHDRGETINDEX(TemperatureSensor,PotentialMin,double)

CHDRGET(TemperatureSensor,AmbientTemperature,double)
CHDRGET(TemperatureSensor,AmbientTemperatureMax,double)
CHDRGET(TemperatureSensor,AmbientTemperatureMin,double)

CHDRGETSETINDEX(TemperatureSensor, ThermocoupleType, CPhidgetTemperatureSensor_ThermocoupleType)

#ifndef EXTERNALPROTO
#define TEMPSENSOR_MAXSENSORS 8

#define GAIN 85.0
#define OFFSET_200 -6.5
#define OFFSET_300 ((200.0/237.0)*5.0)

struct _CPhidgetTemperatureSensor {
	CPhidget phid;

	int (CCONV *fptrTemperatureChange)(CPhidgetTemperatureSensorHandle, void *, int, double);           
	void *fptrTemperatureChangeptr;

	double AmbientTemperature;
	double Temperature[TEMPSENSOR_MAXSENSORS];
	double Potential[TEMPSENSOR_MAXSENSORS];

	double lastTrigger[TEMPSENSOR_MAXSENSORS];

	double TempChangeTrigger[TEMPSENSOR_MAXSENSORS];
	CPhidgetTemperatureSensor_ThermocoupleType ThermocoupleType[TEMPSENSOR_MAXSENSORS];

	double ambientTemperatureMax, ambientTemperatureMin;
	double temperatureMax[TEMPSENSOR_MAXSENSORS], temperatureMin[TEMPSENSOR_MAXSENSORS];
	double potentialMax, potentialMin;
} typedef CPhidgetTemperatureSensorInfo;
#endif

#endif
